//  
//  MainWindow.cs
//  
//  Author:
//       Vsevolod Kukol <sevo@sevo.org>
// 
//  Copyright (c) 2010 Vsevolod Kukol
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
// 
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.

using System;
using System.IO;
using Gtk;

public partial class MainWindow : Gtk.Window
{

    private void LoadFromFile(String Filename)
    {

        chkRESTORE_ORIGINAL_BOOT_ANI.Active = true;
        chkRESTORE_ORIGINAL_THEME.Active = true;

        StreamReader config_file = new StreamReader(Filename);
        String Line, Varname = "";
        Boolean LauncherSelected = false;
        while (config_file.Peek() >= 0)
        {
            Line = config_file.ReadLine();
            Varname = Line.Trim((char)'#');
            Varname = Varname.Split('=')[0];

            switch (Varname)
            {
                case "DEBUG":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkDEBUG.Active = true;
                    else
                        chkDEBUG.Active = false;
                    break;
                case "RESTORE_BACKUP":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkRESTORE_BACKUP.Active = true;
                    else
                        chkRESTORE_BACKUP.Active = false;
                    break;
                case "REMOVE_ALARM_CLOCK":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_ALARM_CLOCK.Active = true;
                    else
                        chkREMOVE_ALARM_CLOCK.Active = false;
                    break;
                case "REMOVE_AUDIO_EFFECT":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_AUDIO_EFFECT.Active = true;
                    else
                        chkREMOVE_AUDIO_EFFECT.Active = false;
                    break;
                case "REMOVE_BROWSER":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_BROWSER.Active = true;
                    else
                        chkREMOVE_BROWSER.Active = false;
                    break;
                case "REMOVE_CALCULATOR":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_CALCULATOR.Active = true;
                    else
                        chkREMOVE_CALCULATOR.Active = false;
                    break;
                case "REMOVE_CAMERA_MOTO":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_CAMERA_MOTO.Active = true;
                    else
                        chkREMOVE_CAMERA_MOTO.Active = false;
                    break;
                case "REMOVE_DOCK":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_DOCK.Active = true;
                    else
                        chkREMOVE_DOCK.Active = false;
                    break;
                case "REMOVE_EMAIL":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_EMAIL.Active = true;
                    else
                        chkREMOVE_EMAIL.Active = false;
                    break;
                case "REMOVE_FACEBOOK":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_FACEBOOK.Active = true;
                    else
                        chkREMOVE_FACEBOOK.Active = false;
                    break;
                case "REMOVE_GESTURES":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_GESTURES.Active = true;
                    else
                        chkREMOVE_GESTURES.Active = false;
                    break;
                case "REMOVE_GMAIL":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_GMAIL.Active = true;
                    else
                        chkREMOVE_GMAIL.Active = false;
                    break;
                case "REMOVE_HELPCENTER":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_HELPCENTER.Active = true;
                    else
                        chkREMOVE_HELPCENTER.Active = false;
                    break;
                case "REMOVE_LATINIME":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_LATINIME.Active = true;
                    else
                        chkREMOVE_LATINIME.Active = false;
                    break;
                case "REMOVE_LATINIMETUTORIAL":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_LATINIMETUTORIAL.Active = true;
                    else
                        chkREMOVE_LATINIMETUTORIAL.Active = false;
                    break;
                case "REMOVE_MAPS":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_MAPS.Active = true;
                    else
                        chkREMOVE_MAPS.Active = false;
                    break;
                case "REMOVE_MEDIAGALLERY":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_MEDIAGALLERY.Active = true;
                    else
                        chkREMOVE_MEDIAGALLERY.Active = false;
                    break;
                case "REMOVE_MOTACCUWEATHERWIDGET":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_MOTACCUWEATHERWIDGET.Active = true;
                    else
                        chkREMOVE_MOTACCUWEATHERWIDGET.Active = false;
                    break;
                case "REMOVE_MOTOCAL":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_MOTOCAL.Active = true;
                    else
                        chkREMOVE_MOTOCAL.Active = false;
                    break;
                case "REMOVE_MOTOCARDOCK":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_MOTOCARDOCK.Active = true;
                    else
                        chkREMOVE_MOTOCARDOCK.Active = false;
                    break;
                case "REMOVE_MOTOGAL":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_MOTOGAL.Active = true;
                    else
                        chkREMOVE_MOTOGAL.Active = false;
                    break;
                case "REMOVE_MOTONAV":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_MOTONAV.Active = true;
                    else
                        chkREMOVE_MOTONAV.Active = false;
                    break;
                case "REMOVE_MUSIC":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_MUSIC.Active = true;
                    else
                        chkREMOVE_MUSIC.Active = false;
                    break;
                case "REMOVE_PERSONALPORTAL":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_PERSONALPORTAL.Active = true;
                    else
                        chkREMOVE_PERSONALPORTAL.Active = false;
                    break;
                case "REMOVE_QUICKOFFICE":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_QUICKOFFICE.Active = true;
                    else
                        chkREMOVE_QUICKOFFICE.Active = false;
                    break;
                case "REMOVE_SOUNDRECORDER":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_SOUNDRECORDER.Active = true;
                    else
                        chkREMOVE_SOUNDRECORDER.Active = false;
                    break;
                case "REMOVE_STK":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_STK.Active = true;
                    else
                        chkREMOVE_STK.Active = false;
                    break;
                case "REMOVE_STREET":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_STREET.Active = true;
                    else
                        chkREMOVE_STREET.Active = false;
                    break;
                case "REMOVE_TALK":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_TALK.Active = true;
                    else
                        chkREMOVE_TALK.Active = false;
                    break;
                case "REMOVE_TTSSERVICE":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_TTSSERVICE.Active = true;
                    else
                        chkREMOVE_TTSSERVICE.Active = false;
                    break;
                case "REMOVE_VIDEOPLAYERMOTO":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_VIDEOPLAYERMOTO.Active = true;
                    else
                        chkREMOVE_VIDEOPLAYERMOTO.Active = false;
                    break;
                case "REMOVE_VSUITEAPP":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_VSUITEAPP.Active = true;
                    else
                        chkREMOVE_VSUITEAPP.Active = false;
                    break;
                case "REMOVE_WORLDCLOCKWIDGET":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_WORLDCLOCKWIDGET.Active = true;
                    else
                        chkREMOVE_WORLDCLOCKWIDGET.Active = false;
                    break;
                case "REMOVE_YOUTUBE":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREMOVE_YOUTUBE.Active = true;
                    else
                        chkREMOVE_YOUTUBE.Active = false;
                    break;


                case "INSTALL_NEXUS_MUSIC":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")) & !(chkREMOVE_MUSIC.Active))
                        chkINSTALL_NEXUS_MUSIC.Active = true;
                    else
                        chkINSTALL_NEXUS_MUSIC.Active = false;
                    break;
                case "INSTALL_NEXUS_DESKCLOCK":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkINSTALL_NEXUS_DESKCLOCK.Active = true;
                    else
                        chkINSTALL_NEXUS_DESKCLOCK.Active = false;
                    break;
                case "INSTALL_NEXUS_3DGALLERY":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkINSTALL_NEXUS_3DGALLERY.Active = true;
                    else
                        chkINSTALL_NEXUS_3DGALLERY.Active = false;
                    break;
                case "INSTALL_NEXUS_GENIEWIDGET":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkINSTALL_NEXUS_GENIEWIDGET.Active = true;
                    else
                        chkINSTALL_NEXUS_GENIEWIDGET.Active = false;
                    break;


                case "INSTALL_HTC_IME":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkINSTALL_HTC_IME.Active = true;
                    else
                        chkINSTALL_HTC_IME.Active = false;
                    break;
                case "INSTALL_NAVIMAPS":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")) & !(chkREMOVE_MAPS.Active))
                        chkINSTALL_NAVIMAPS.Active = true;
                    else
                        chkINSTALL_NAVIMAPS.Active = false;
                    break;
                case "INSTALL_OLD_CAMERA":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkINSTALL_OLD_CAMERA.Active = true;
                    else
                        chkINSTALL_OLD_CAMERA.Active = false;
                    break;
                case "INSTALL_USER_APPS":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkINSTALL_USER_APPS.Active = true;
                    else
                        chkINSTALL_USER_APPS.Active = false;
                    break;


                case "REPLACE_LAUNCHER":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkREPLACE_LAUNCHER.Active = true;
                    else
                        chkREPLACE_LAUNCHER.Active = false;
                    break;
                case "INSTALL_LAUNCHER_HELIX":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                    {
                        chkINSTALL_LAUNCHER_HELIX.Active = true;
                        LauncherSelected = true;
                    }
                    else
                        chkINSTALL_LAUNCHER_HELIX.Active = false;
                    break;
                case "INSTALL_LAUNCHER_HELIX2":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                    {
                        chkINSTALL_LAUNCHER_HELIX2.Active = true;
                        LauncherSelected = true;
                    }
                    else
                        chkINSTALL_LAUNCHER_HELIX2.Active = false;
                    break;


                case "INSTALL_BOOT_ANIMATION_BIOS":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkINSTALL_BOOT_ANIMATION_BIOS.Active = true;
                    else
                        chkINSTALL_BOOT_ANIMATION_BIOS.Active = false;
                    break;
                case "INSTALL_BOOT_ANIMATION_DROID":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkINSTALL_BOOT_ANIMATION_DROID.Active = true;
                    else
                        chkINSTALL_BOOT_ANIMATION_DROID.Active = false;
                    break;


                case "INSTALL_THEME_GLASS_STONE":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkINSTALL_THEME_GLASS_STONE.Active = true;
                    else
                        chkINSTALL_THEME_GLASS_STONE.Active = false;
                    break;
                case "INSTALL_THEME_BLACK":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkINSTALL_THEME_BLACK.Active = true;
                    else
                        chkINSTALL_THEME_BLACK.Active = false;
                    break;
                case "INSTALL_THEME_CUSTOM":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkINSTALL_THEME_CUSTOM.Active = true;
                    else
                        chkINSTALL_THEME_CUSTOM.Active = false;
                    break;

                case "INSTALL_OCFLAC":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkINSTALL_OCFLAC.Active = true;
                    else
                        chkINSTALL_OCFLAC.Active = false;
                    break;
                case "INSTALL_BUSYBOX":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkINSTALL_BUSYBOX.Active = true;
                    else
                        chkINSTALL_BUSYBOX.Active = false;
                    break;
                case "INSTALL_BUSYBOX_LINK_XBIN":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkINSTALL_BUSYBOX_LINK_XBIN.Active = true;
                    else
                        chkINSTALL_BUSYBOX_LINK_XBIN.Active = false;
                    break;
                case "INSTALL_ROOT":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkINSTALL_ROOT.Active = true;
                    else
                        chkINSTALL_ROOT.Active = false;
                    break;
                case "INSTALL_MEMORY_HACK":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkINSTALL_MEMORY_HACK.Active = true;
                    else
                        chkINSTALL_MEMORY_HACK.Active = false;
                    break;

                case "PATCH_BUILD_PROP":
                    if (Line.Contains("yes") & !(Line.StartsWith("#")))
                        chkPATCH_BUILD_PROP.Active = true;
                    else
                        chkPATCH_BUILD_PROP.Active = false;
                    break;
                case "PATCH_BUILD_PROP_BUILD_STRING":
                    if (!(Line.StartsWith("#")))
                    {
                        chkPATCH_BUILD_PROP_BUILD_STRING.Active = true;
                        String Val = Line.Split('=')[1];
                        Val = Val.Trim((char)'"');
                        if (Val != "")
                            txtPATCH_BUILD_PROP_BUILD_STRING.Text = Val;
                    }
                    else
                        chkPATCH_BUILD_PROP_BUILD_STRING.Active = false;
                    break;
                case "PATCH_BUILD_PROP_CAMERA_RES":
                    if (!(Line.StartsWith("#")))
                    {
                        chkPATCH_BUILD_PROP_CAMERA_RES.Active = true;
                        String Val = Line.Split('=')[1];
                        Val = Val.Trim((char)'"');
                        if (Val == "PAL")
                            cmbPATCH_BUILD_PROP_CAMERA_RES.Active = 0;
                        else if (Val == "STOCK")
                            cmbPATCH_BUILD_PROP_CAMERA_RES.Active = 1;
                        else if (Val == "SCREEN")
                            cmbPATCH_BUILD_PROP_CAMERA_RES.Active = 2;
                        else
                        {
                            try
                            {
                                int iVal = int.Parse(Val.Split('x')[0]);
                                txtCamResX.Value = iVal;
                                iVal = int.Parse(Val.Split('x')[1]);
                                txtCamResY.Value = iVal;
                                cmbPATCH_BUILD_PROP_CAMERA_RES.Active = 3;
                            }
                            catch (FormatException)
                            {
                                txtCamResX.Value = 0;
                                txtCamResY.Value = 0;
                                cmbPATCH_BUILD_PROP_CAMERA_RES.Active = 1;
                            }
                        }
                    }
                    else
                        chkPATCH_BUILD_PROP_CAMERA_RES.Active = false;
                    break;
                case "PATCH_BUILD_PROP_CAMERA_VID_BPS":
                    if (!(Line.StartsWith("#")))
                    {
                        chkPATCH_BUILD_PROP_CAMERA_VID_BPS.Active = true;
                        String Val = Line.Split('=')[1];
                        Val = Val.Trim((char)'"');
                        if (Val != "")
                        {
                            try
                            {
                                long iVal = long.Parse(Val);
                                txtPATCH_BUILD_PROP_CAMERA_VID_BPS.Value = iVal;
                            }
                            catch (FormatException)
                            {
                                txtPATCH_BUILD_PROP_CAMERA_VID_BPS.Value = 0;
                                chkPATCH_BUILD_PROP_CAMERA_VID_BPS.Active = false;
                            }
                        }
                    }
                    else
                        chkPATCH_BUILD_PROP_CAMERA_VID_BPS.Active = false;
                    break;
                case "PATCH_BUILD_PROP_CAMERA_VID_FPS":
                    if (!(Line.StartsWith("#")))
                    {
                        chkPATCH_BUILD_PROP_CAMERA_VID_FPS.Active = true;
                        String Val = Line.Split('=')[1];
                        Val = Val.Trim((char)'"');
                        if (Val != "")
                        {
                            try
                            {
                                byte iVal = byte.Parse(Val);
                                txtPATCH_BUILD_PROP_CAMERA_VID_FPS.Value = iVal;
                            }
                            catch
                            {
                                txtPATCH_BUILD_PROP_CAMERA_VID_FPS.Value = 0;
                                chkPATCH_BUILD_PROP_CAMERA_VID_FPS.Active = false;
                            }
                        }
                    }
                    else
                        chkPATCH_BUILD_PROP_CAMERA_VID_FPS.Active = false;
                    break;
                case "PATCH_BUILD_PROP_CAMERA_AUD_BPS":
                    if (!(Line.StartsWith("#")))
                    {
                        chkPATCH_BUILD_PROP_CAMERA_AUD_BPS.Active = true;
                        String Val = Line.Split('=')[1];
                        Val = Val.Trim((char)'"');
                        if (Val != "")
                        {
                            try
                            {
                                long iVal = long.Parse(Val);
                                txtPATCH_BUILD_PROP_CAMERA_AUD_BPS.Value = iVal;
                            }
                            catch (FormatException)
                            {
                                txtPATCH_BUILD_PROP_CAMERA_AUD_BPS.Value = 0;
                                chkPATCH_BUILD_PROP_CAMERA_AUD_BPS.Active = false;
                            }
                        }
                    }
                    else
                        chkPATCH_BUILD_PROP_CAMERA_AUD_BPS.Active = false;
                    break;
                case "PATCH_BUILD_PROP_CAMERA_AUD_FREQ":
                    if (!(Line.StartsWith("#")))
                    {
                        chkPATCH_BUILD_PROP_CAMERA_AUD_FREQ.Active = true;
                        String Val = Line.Split('=')[1];
                        Val = Val.Trim((char)'"');
                        if (Val != "")
                        {
                            try
                            {
                                long iVal = long.Parse(Val);
                                txtPATCH_BUILD_PROP_CAMERA_AUD_FREQ.Value = iVal;
                            }
                            catch (FormatException)
                            {
                                txtPATCH_BUILD_PROP_CAMERA_AUD_FREQ.Value = 0;
                                chkPATCH_BUILD_PROP_CAMERA_AUD_FREQ.Active = false;
                            }
                        }
                    }
                    else
                        chkPATCH_BUILD_PROP_CAMERA_AUD_FREQ.Active = false;
                    break;

                default:
                    break;
            }
        }
        config_file.Close();
        if (LauncherSelected)
            chkINSTALL_LAUNCHER.Active = true;
        else
        {
            chkINSTALL_LAUNCHER.Active = false;
            chkREPLACE_LAUNCHER.Active = false;
        }
    }
	
	public void SetAllWidgetTooltips(Gtk.Container parent)
	{
		foreach (Gtk.Widget child in parent.AllChildren)
		{
			if (child is Gtk.Container)
			{
				Gtk.Container container = child as Gtk.Container;
				SetAllWidgetTooltips(container);
			}
			if (child is Gtk.CheckButton)
			{
				child.TooltipText = help.GetHelpText(child);
				
        		child.FocusInEvent +=  new Gtk.FocusInEventHandler(this.OnWidgetClicked);
			}
			else
				child.FocusInEvent +=  new Gtk.FocusInEventHandler(this.ClearHelpLabel);
		}
	}

	

    public MainWindow()
        : base(Gtk.WindowType.Toplevel)
    {
        Build();
		
		SetAllWidgetTooltips(this);

        if (File.Exists("kmodder.cfg.default"))
            LoadFromFile("kmodder.cfg.default");
		else if (File.Exists("/KMODDER/kmodder.cfg.default"))
            LoadFromFile("/KMODDER/kmodder.cfg.default");
        else
        {
            MessageDialog md = 
				new MessageDialog(this,
				                  DialogFlags.DestroyWithParent,
				                  MessageType.Error,
				                  ButtonsType.Close,
				                  "File \"kmodder.cfg.default\" not found!");

            int result = md.Run();
            md.Destroy();
        }

        if (File.Exists("kmodder.cfg"))
            LoadFromFile("kmodder.cfg");
		else if (File.Exists("/KMODDER/kmodder.cfg"))
            LoadFromFile("/KMODDER/kmodder.cfg");
        else
        {
            MessageDialog md = 
				new MessageDialog(this,
                                  DialogFlags.DestroyWithParent,
                                  MessageType.Warning,
                                  ButtonsType.Close,
                                  "File \"kmodder.cfg\" not found!\nUsing default configuration.");

            int result = md.Run();
            md.Destroy();
        }
    }

    protected void OnDeleteEvent(object sender, DeleteEventArgs a)
    {
        Application.Quit();
        a.RetVal = true;
    }
    protected virtual void OnBtnCancelClicked(object sender, System.EventArgs e)
    {
        Application.Quit();
    }

    protected virtual void OnBtnSaveClicked(object sender, System.EventArgs e)
    {

        StreamWriter config_file_new;
		
		
        if (File.Exists("/KMODDER/kmodder.cfg.default"))
        	config_file_new = new StreamWriter("/KMODDER/kmodder.cfg", false);
		else
        	config_file_new = new StreamWriter("kmodder.cfg", false);
		
        config_file_new.NewLine = "\n";
		
		StreamReader config_file;
		
        if (File.Exists("kmodder.cfg.default"))
        	config_file = new StreamReader("kmodder.cfg.default");
		else if (File.Exists("/KMODDER/kmodder.cfg.default"))
        	config_file = new StreamReader("/KMODDER/kmodder.cfg.default");
        else
        {
            MessageDialog md = new MessageDialog(this,
                              DialogFlags.DestroyWithParent,
                              MessageType.Error,
                              ButtonsType.Close,
			                  "File \"kmodder.cfg.default\" not found!");

            int result = md.Run();
            md.Destroy();
			return;
        }
		
        String Line, Varname = "";
        while (config_file.Peek() >= 0)
        {
            Line = config_file.ReadLine();
            Varname = Line.Trim((char)'#');
            Varname = Varname.Split('=')[0];

            switch (Varname)
            {
                case "DEBUG":
                    if (chkDEBUG.Active)
                        config_file_new.WriteLine("DEBUG=\"yes\"");
                    else
                        config_file_new.WriteLine("#DEBUG=\"yes\"");
                    break;
                case "RESTORE_BACKUP":
                    if (chkRESTORE_BACKUP.Active)
                        config_file_new.WriteLine("RESTORE_BACKUP=\"yes\"");
                    else
                        config_file_new.WriteLine("#RESTORE_BACKUP=\"yes\"");
                    break;
                case "REMOVE_ALARM_CLOCK":
                    if (chkREMOVE_ALARM_CLOCK.Active)
                        config_file_new.WriteLine("REMOVE_ALARM_CLOCK=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_ALARM_CLOCK=\"yes\"");
                    break;
                case "REMOVE_AUDIO_EFFECT":
                    if (chkREMOVE_AUDIO_EFFECT.Active)
                        config_file_new.WriteLine("REMOVE_AUDIO_EFFECT=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_AUDIO_EFFECT=\"yes\"");
                    break;
                case "REMOVE_BROWSER":
                    if (chkREMOVE_BROWSER.Active)
                        config_file_new.WriteLine("REMOVE_BROWSER=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_BROWSER=\"yes\"");
                    break;
                case "REMOVE_CALCULATOR":
                    if (chkREMOVE_CALCULATOR.Active)
                        config_file_new.WriteLine("REMOVE_CALCULATOR=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_CALCULATOR=\"yes\"");
                    break;
                case "REMOVE_CAMERA_MOTO":
                    if (chkREMOVE_CAMERA_MOTO.Active)
                        config_file_new.WriteLine("REMOVE_CAMERA_MOTO=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_CAMERA_MOTO=\"yes\"");
                    break;
                case "REMOVE_DOCK":
                    if (chkREMOVE_DOCK.Active)
                        config_file_new.WriteLine("REMOVE_DOCK=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_DOCK=\"yes\"");
                    break;
                case "REMOVE_EMAIL":
                    if (chkREMOVE_EMAIL.Active)
                        config_file_new.WriteLine("REMOVE_EMAIL=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_EMAIL=\"yes\"");
                    break;
                case "REMOVE_FACEBOOK":
                    if (chkREMOVE_FACEBOOK.Active)
                        config_file_new.WriteLine("REMOVE_FACEBOOK=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_FACEBOOK=\"yes\"");
                    break;
                case "REMOVE_GESTURES":
                    if (chkREMOVE_GESTURES.Active)
                        config_file_new.WriteLine("REMOVE_GESTURES=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_GESTURES=\"yes\"");
                    break;
                case "REMOVE_GMAIL":
                    if (chkREMOVE_GMAIL.Active)
                        config_file_new.WriteLine("REMOVE_GMAIL=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_GMAIL=\"yes\"");
                    break;
                case "REMOVE_HELPCENTER":
                    if (chkREMOVE_HELPCENTER.Active)
                        config_file_new.WriteLine("REMOVE_HELPCENTER=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_HELPCENTER=\"yes\"");
                    break;
                case "REMOVE_LATINIME":
                    if (chkREMOVE_LATINIME.Active)
                        config_file_new.WriteLine("REMOVE_LATINIME=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_LATINIME=\"yes\"");
                    break;
                case "REMOVE_LATINIMETUTORIAL":
                    if (chkREMOVE_LATINIMETUTORIAL.Active)
                        config_file_new.WriteLine("REMOVE_LATINIMETUTORIAL=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_LATINIMETUTORIAL=\"yes\"");
                    break;
                case "REMOVE_MAPS":
                    if (chkREMOVE_MAPS.Active)
                        config_file_new.WriteLine("REMOVE_MAPS=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_MAPS=\"yes\"");
                    break;
                case "REMOVE_MEDIAGALLERY":
                    if (chkREMOVE_MEDIAGALLERY.Active)
                        config_file_new.WriteLine("REMOVE_MEDIAGALLERY=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_MEDIAGALLERY=\"yes\"");
                    break;
                case "REMOVE_MOTACCUWEATHERWIDGET":
                    if (chkREMOVE_MEDIAGALLERY.Active)
                        config_file_new.WriteLine("REMOVE_MOTACCUWEATHERWIDGET=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_MOTACCUWEATHERWIDGET=\"yes\"");
                    break;
                case "REMOVE_MOTOCAL":
                    if (chkREMOVE_MOTOCAL.Active)
                        config_file_new.WriteLine("REMOVE_MOTOCAL=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_MOTOCAL=\"yes\"");
                    break;
                case "REMOVE_MOTOCARDOCK":
                    if (chkREMOVE_MOTOCARDOCK.Active)
                        config_file_new.WriteLine("REMOVE_MOTOCARDOCK=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_MOTOCARDOCK=\"yes\"");
                    break;
                case "REMOVE_MOTOGAL":
                    if (chkREMOVE_MOTOGAL.Active)
                        config_file_new.WriteLine("REMOVE_MOTOGAL=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_MOTOGAL=\"yes\"");
                    break;
                case "REMOVE_MOTONAV":
                    if (chkREMOVE_MOTONAV.Active)
                        config_file_new.WriteLine("REMOVE_MOTONAV=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_MOTONAV=\"yes\"");
                    break;
                case "REMOVE_MUSIC":
                    if (chkREMOVE_MUSIC.Active)
                        config_file_new.WriteLine("REMOVE_MUSIC=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_MUSIC=\"yes\"");
                    break;
                case "REMOVE_PERSONALPORTAL":
                    if (chkREMOVE_PERSONALPORTAL.Active)
                        config_file_new.WriteLine("REMOVE_PERSONALPORTAL=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_PERSONALPORTAL=\"yes\"");
                    break;
                case "REMOVE_QUICKOFFICE":
                    if (chkREMOVE_QUICKOFFICE.Active)
                        config_file_new.WriteLine("REMOVE_QUICKOFFICE=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_QUICKOFFICE=\"yes\"");
                    break;
                case "REMOVE_SOUNDRECORDER":
                    if (chkREMOVE_SOUNDRECORDER.Active)
                        config_file_new.WriteLine("REMOVE_SOUNDRECORDER=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_SOUNDRECORDER=\"yes\"");
                    break;
                case "REMOVE_STK":
                    if (chkREMOVE_STK.Active)
                        config_file_new.WriteLine("REMOVE_STK=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_STK=\"yes\"");
                    break;
                case "REMOVE_STREET":
                    if (chkREMOVE_STREET.Active)
                        config_file_new.WriteLine("REMOVE_STREET=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_STREET=\"yes\"");
                    break;
                case "REMOVE_TALK":
                    if (chkREMOVE_TALK.Active)
                        config_file_new.WriteLine("REMOVE_TALK=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_TALK=\"yes\"");
                    break;
                case "REMOVE_TTSSERVICE":
                    if (chkREMOVE_TTSSERVICE.Active)
                        config_file_new.WriteLine("REMOVE_TTSSERVICE=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_TTSSERVICE=\"yes\"");
                    break;
                case "REMOVE_VIDEOPLAYERMOTO":
                    if (chkREMOVE_VIDEOPLAYERMOTO.Active)
                        config_file_new.WriteLine("REMOVE_VIDEOPLAYERMOTO=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_VIDEOPLAYERMOTO=\"yes\"");
                    break;
                case "REMOVE_VSUITEAPP":
                    if (chkREMOVE_VSUITEAPP.Active)
                        config_file_new.WriteLine("REMOVE_VSUITEAPP=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_VSUITEAPP=\"yes\"");
                    break;
                case "REMOVE_WORLDCLOCKWIDGET":
                    if (chkREMOVE_WORLDCLOCKWIDGET.Active)
                        config_file_new.WriteLine("REMOVE_WORLDCLOCKWIDGET=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_WORLDCLOCKWIDGET=\"yes\"");
                    break;
                case "REMOVE_YOUTUBE":
                    if (chkREMOVE_YOUTUBE.Active)
                        config_file_new.WriteLine("REMOVE_YOUTUBE=\"yes\"");
                    else
                        config_file_new.WriteLine("#REMOVE_YOUTUBE=\"yes\"");
                    break;


                case "INSTALL_NEXUS_MUSIC":
                    if (chkINSTALL_NEXUS_MUSIC.Active)
                        config_file_new.WriteLine("INSTALL_NEXUS_MUSIC=\"yes\"");
                    else
                        config_file_new.WriteLine("#INSTALL_NEXUS_MUSIC=\"yes\"");
                    break;
                case "INSTALL_NEXUS_DESKCLOCK":
                    if (chkINSTALL_NEXUS_DESKCLOCK.Active)
                        config_file_new.WriteLine("INSTALL_NEXUS_DESKCLOCK=\"yes\"");
                    else
                        config_file_new.WriteLine("#INSTALL_NEXUS_DESKCLOCK=\"yes\"");
                    break;
                case "INSTALL_NEXUS_3DGALLERY":
                    if (chkINSTALL_NEXUS_3DGALLERY.Active)
                        config_file_new.WriteLine("INSTALL_NEXUS_3DGALLERY=\"yes\"");
                    else
                        config_file_new.WriteLine("#INSTALL_NEXUS_3DGALLERY=\"yes\"");
                    break;
                case "INSTALL_NEXUS_GENIEWIDGET":
                    if (chkINSTALL_NEXUS_GENIEWIDGET.Active)
                        config_file_new.WriteLine("INSTALL_NEXUS_GENIEWIDGET=\"yes\"");
                    else
                        config_file_new.WriteLine("#INSTALL_NEXUS_GENIEWIDGET=\"yes\"");
                    break;

                case "INSTALL_HTC_IME":
                    if (chkINSTALL_HTC_IME.Active)
                        config_file_new.WriteLine("INSTALL_HTC_IME=\"yes\"");
                    else
                        config_file_new.WriteLine("#INSTALL_HTC_IME=\"yes\"");
                    break;
                case "INSTALL_NAVIMAPS":
                    if (chkINSTALL_NAVIMAPS.Active)
                        config_file_new.WriteLine("INSTALL_NAVIMAPS=\"yes\"");
                    else
                        config_file_new.WriteLine("#INSTALL_NAVIMAPS=\"yes\"");
                    break;
                case "INSTALL_OLD_CAMERA":
                    if (chkINSTALL_OLD_CAMERA.Active)
                        config_file_new.WriteLine("INSTALL_OLD_CAMERA=\"yes\"");
                    else
                        config_file_new.WriteLine("#INSTALL_OLD_CAMERA=\"yes\"");
                    break;
                case "INSTALL_USER_APPS":
                    if (chkINSTALL_USER_APPS.Active)
                        config_file_new.WriteLine("INSTALL_USER_APPS=\"yes\"");
                    else
                        config_file_new.WriteLine("#INSTALL_USER_APPS=\"yes\"");
                    break;

                case "REPLACE_LAUNCHER":
                    if (chkREPLACE_LAUNCHER.Active & chkINSTALL_LAUNCHER.Active)
                        config_file_new.WriteLine("REPLACE_LAUNCHER=\"yes\"");
                    else
                        config_file_new.WriteLine("#REPLACE_LAUNCHER=\"yes\"");
                    break;
                case "INSTALL_LAUNCHER_HELIX":
                    if (chkINSTALL_LAUNCHER_HELIX.Active & chkINSTALL_LAUNCHER.Active)
                        config_file_new.WriteLine("INSTALL_LAUNCHER_HELIX=\"yes\"");
                    else
                        config_file_new.WriteLine("#INSTALL_LAUNCHER_HELIX=\"yes\"");
                    break;
                case "INSTALL_LAUNCHER_HELIX2":
                    if (chkINSTALL_LAUNCHER_HELIX2.Active & chkINSTALL_LAUNCHER.Active)
                        config_file_new.WriteLine("INSTALL_LAUNCHER_HELIX2=\"yes\"");
                    else
                        config_file_new.WriteLine("#INSTALL_LAUNCHER_HELIX2=\"yes\"");
                    break;

                case "INSTALL_BOOT_ANIMATION_BIOS":
                    if (chkINSTALL_BOOT_ANIMATION_BIOS.Active)
                        config_file_new.WriteLine("INSTALL_BOOT_ANIMATION_BIOS=\"yes\"");
                    else
                        config_file_new.WriteLine("#INSTALL_BOOT_ANIMATION_BIOS=\"yes\"");
                    break;
                case "INSTALL_BOOT_ANIMATION_DROID":
                    if (chkINSTALL_BOOT_ANIMATION_DROID.Active)
                        config_file_new.WriteLine("INSTALL_BOOT_ANIMATION_DROID=\"yes\"");
                    else
                        config_file_new.WriteLine("#INSTALL_BOOT_ANIMATION_DROID=\"yes\"");
                    break;


                case "INSTALL_THEME_GLASS_STONE":
                    if (chkINSTALL_THEME_GLASS_STONE.Active)
                        config_file_new.WriteLine("INSTALL_THEME_GLASS_STONE=\"yes\"");
                    else
                        config_file_new.WriteLine("#INSTALL_THEME_GLASS_STONE=\"yes\"");
                    break;
                case "INSTALL_THEME_BLACK":
                    if (chkINSTALL_THEME_BLACK.Active)
                        config_file_new.WriteLine("INSTALL_THEME_BLACK=\"yes\"");
                    else
                        config_file_new.WriteLine("#INSTALL_THEME_BLACK=\"yes\"");
                    break;
                case "INSTALL_THEME_CUSTOM":
                    if (chkINSTALL_THEME_CUSTOM.Active)
                        config_file_new.WriteLine("INSTALL_THEME_CUSTOM=\"yes\"");
                    else
                        config_file_new.WriteLine("#INSTALL_THEME_CUSTOM=\"yes\"");
                    break;

                case "INSTALL_OCFLAC":
                    if (chkINSTALL_OCFLAC.Active)
                        config_file_new.WriteLine("INSTALL_OCFLAC=\"yes\"");
                    else
                        config_file_new.WriteLine("#INSTALL_OCFLAC=\"yes\"");
                    break;
                case "INSTALL_BUSYBOX":
                    if (chkINSTALL_BUSYBOX.Active)
                        config_file_new.WriteLine("INSTALL_BUSYBOX=\"yes\"");
                    else
                        config_file_new.WriteLine("#INSTALL_BUSYBOX=\"yes\"");
                    break;
                case "INSTALL_BUSYBOX_LINK_XBIN":
                    if (chkINSTALL_BUSYBOX_LINK_XBIN.Active)
                        config_file_new.WriteLine("INSTALL_BUSYBOX_LINK_XBIN=\"yes\"");
                    else
                        config_file_new.WriteLine("#INSTALL_BUSYBOX_LINK_XBIN=\"yes\"");
                    break;
                case "INSTALL_ROOT":
                    if (chkINSTALL_ROOT.Active)
                        config_file_new.WriteLine("INSTALL_ROOT=\"yes\"");
                    else
                        config_file_new.WriteLine("#INSTALL_ROOT=\"yes\"");
                    break;
                case "INSTALL_MEMORY_HACK":
                    if (chkINSTALL_MEMORY_HACK.Active)
                        config_file_new.WriteLine("INSTALL_MEMORY_HACK=\"yes\"");
                    else
                        config_file_new.WriteLine("#INSTALL_MEMORY_HACK=\"yes\"");
                    break;


                case "PATCH_BUILD_PROP":
                    if (chkPATCH_BUILD_PROP.Active)
                        config_file_new.WriteLine("PATCH_BUILD_PROP=\"yes\"");
                    else
                        config_file_new.WriteLine("#PATCH_BUILD_PROP=\"yes\"");
                    break;

                case "PATCH_BUILD_PROP_BUILD_STRING":
                    if (chkPATCH_BUILD_PROP_BUILD_STRING.Active)
                        config_file_new.WriteLine("PATCH_BUILD_PROP_BUILD_STRING=\"" + txtPATCH_BUILD_PROP_BUILD_STRING.Text + "\"");
                    else
                        config_file_new.WriteLine("#PATCH_BUILD_PROP_BUILD_STRING=\"\"");
                    break;

                case "PATCH_BUILD_PROP_CAMERA_RES":
                    if (chkPATCH_BUILD_PROP_CAMERA_RES.Active)
                    {
                        if (cmbPATCH_BUILD_PROP_CAMERA_RES.Active == 0)
                            config_file_new.WriteLine("PATCH_BUILD_PROP_CAMERA_RES=\"PAL\"");
                        else if (cmbPATCH_BUILD_PROP_CAMERA_RES.Active == 1)
                            config_file_new.WriteLine("PATCH_BUILD_PROP_CAMERA_RES=\"STOCK\"");
                        else if (cmbPATCH_BUILD_PROP_CAMERA_RES.Active == 2)
                            config_file_new.WriteLine("PATCH_BUILD_PROP_CAMERA_RES=\"SCREEN\"");
                        else if (cmbPATCH_BUILD_PROP_CAMERA_RES.Active == 3)
                        {
                            try
                            {
                                int x = int.Parse(txtCamResX.Text);
                                int y = int.Parse(txtCamResY.Text);
                                config_file_new.WriteLine("PATCH_BUILD_PROP_CAMERA_RES=\"" + x.ToString() + "x" + y.ToString() + "\"");
                            }
                            catch
                            {
                                cmbPATCH_BUILD_PROP_CAMERA_RES.Active = 1;
                                txtCamResX.Value = txtCamResY.Value = 0;
                                config_file_new.WriteLine("PATCH_BUILD_PROP_CAMERA_RES=\"STOCK\"");
                            }
                        }
                        else
                            config_file_new.WriteLine("PATCH_BUILD_PROP_CAMERA_RES=\"STOCK\"");
                    }
                    else
                        config_file_new.WriteLine("#PATCH_BUILD_PROP_CAMERA_RES=\"\"");
                    break;
                case "PATCH_BUILD_PROP_CAMERA_VID_BPS":
                    if (chkPATCH_BUILD_PROP_CAMERA_VID_BPS.Active)
                    {
                        try
                        {
                            long iVal = long.Parse(txtPATCH_BUILD_PROP_CAMERA_VID_BPS.Text);
                            config_file_new.WriteLine("PATCH_BUILD_PROP_CAMERA_VID_BPS=\"" + iVal.ToString() + "\"");
                        }
                        catch
                        {
                            config_file_new.WriteLine("#PATCH_BUILD_PROP_CAMERA_VID_BPS=\"\"");
                        }
                    }
                    else
                        config_file_new.WriteLine("#PATCH_BUILD_PROP_CAMERA_VID_BPS=\"\"");
                    break;
                case "PATCH_BUILD_PROP_CAMERA_VID_FPS":
                    if (chkPATCH_BUILD_PROP_CAMERA_VID_FPS.Active)
                    {
                        try
                        {
                            byte iVal = byte.Parse(txtPATCH_BUILD_PROP_CAMERA_VID_FPS.Text);
                            config_file_new.WriteLine("PATCH_BUILD_PROP_CAMERA_VID_FPS=\"" + iVal.ToString() + "\"");
                        }
                        catch
                        {
                            config_file_new.WriteLine("#PATCH_BUILD_PROP_CAMERA_VID_FPS=\"\"");
                        }
                    }
                    else
                        config_file_new.WriteLine("#PATCH_BUILD_PROP_CAMERA_VID_FPS=\"\"");
                    break;
                case "PATCH_BUILD_PROP_CAMERA_AUD_BPS":
                    if (chkPATCH_BUILD_PROP_CAMERA_VID_BPS.Active)
                    {
                        try
                        {
                            long iVal = long.Parse(txtPATCH_BUILD_PROP_CAMERA_AUD_BPS.Text);
                            config_file_new.WriteLine("PATCH_BUILD_PROP_CAMERA_AUD_BPS=\"" + iVal.ToString() + "\"");
                        }
                        catch
                        {
                            config_file_new.WriteLine("#PATCH_BUILD_PROP_CAMERA_AUD_BPS=\"\"");
                        }
                    }
                    else
                        config_file_new.WriteLine("#PATCH_BUILD_PROP_CAMERA_AUD_BPS=\"\"");
                    break;
                case "PATCH_BUILD_PROP_CAMERA_AUD_FREQ":
                    if (chkPATCH_BUILD_PROP_CAMERA_AUD_FREQ.Active)
                    {
                        try
                        {
                            long iVal = long.Parse(txtPATCH_BUILD_PROP_CAMERA_AUD_FREQ.Text);
                            config_file_new.WriteLine("PATCH_BUILD_PROP_CAMERA_AUD_FREQ=\"" + iVal.ToString() + "\"");
                        }
                        catch
                        {
                            config_file_new.WriteLine("#PATCH_BUILD_PROP_CAMERA_AUD_FREQ=\"\"");
                        }
                    }
                    else
                        config_file_new.WriteLine("#PATCH_BUILD_PROP_CAMERA_AUD_FREQ=\"\"");
                    break;

                default:
                    config_file_new.WriteLine(Line);
                    break;
            }
        }
        config_file_new.Close();
        config_file.Close();



    }

    protected virtual void OnChkREMOVEMUSICToggled(object sender, System.EventArgs e)
    {
        if (chkREMOVE_MUSIC.Active)
            chkINSTALL_NEXUS_MUSIC.Sensitive = false;
        else
            chkINSTALL_NEXUS_MUSIC.Sensitive = true;
    }

    protected virtual void OnChkREMOVEMAPSToggled(object sender, System.EventArgs e)
    {
        if (chkREMOVE_MAPS.Active)
            chkINSTALL_NAVIMAPS.Sensitive = false;
        else
            chkINSTALL_NAVIMAPS.Sensitive = true;
    }

    protected virtual void OnChkINSTALLLAUNCHERToggled(object sender, System.EventArgs e)
    {
        if (chkINSTALL_LAUNCHER.Active)
        {
            chkINSTALL_LAUNCHER_HELIX.Sensitive = true;
            chkINSTALL_LAUNCHER_HELIX2.Sensitive = true;
            chkREPLACE_LAUNCHER.Sensitive = true;
        }
        else
        {
            chkINSTALL_LAUNCHER_HELIX.Sensitive = false;
            chkINSTALL_LAUNCHER_HELIX2.Sensitive = false;
            chkREPLACE_LAUNCHER.Sensitive = false;
        }
    }

    protected virtual void OnBtnLoadClicked(object sender, System.EventArgs e)
    {
        if (File.Exists("kmodder.cfg"))
            LoadFromFile("kmodder.cfg");
		else if (File.Exists("/KMODDER/kmodder.cfg"))
            LoadFromFile("/KMODDER/kmodder.cfg");
        else
        {
            MessageDialog md = new MessageDialog(this,
                                  DialogFlags.DestroyWithParent,
                              MessageType.Error,
                                  ButtonsType.Close, "File \"kmodder.cfg\" not found!\nUsing default configuration.");

            int result = md.Run();
            md.Destroy();
        }
    }

    protected virtual void OnBtnLoadDefaultClicked(object sender, System.EventArgs e)
    {
        if (File.Exists("kmodder.cfg.default"))
            LoadFromFile("kmodder.cfg.default");
		else if (File.Exists("/KMODDER/kmodder.cfg.default"))
            LoadFromFile("/KMODDER/kmodder.cfg.default");
        else
        {
            MessageDialog md = new MessageDialog(this,
                                  DialogFlags.DestroyWithParent,
                              MessageType.Error,
                                  ButtonsType.Close, "File \"kmodder.cfg.default\" not found!");

            int result = md.Run();
            md.Destroy();
        }

    }

    protected virtual void OnChkPATCHBUILDPROPToggled(object sender, System.EventArgs e)
    {
        if (chkPATCH_BUILD_PROP.Active)
        {
            chkPATCH_BUILD_PROP_BUILD_STRING.Sensitive = true;
            chkPATCH_BUILD_PROP_CAMERA_RES.Sensitive = true;
            chkPATCH_BUILD_PROP_CAMERA_VID_BPS.Sensitive = true;
            chkPATCH_BUILD_PROP_CAMERA_VID_FPS.Sensitive = true;
            chkPATCH_BUILD_PROP_CAMERA_AUD_BPS.Sensitive = true;
            chkPATCH_BUILD_PROP_CAMERA_AUD_FREQ.Sensitive = true;
        }
        else
        {
            chkPATCH_BUILD_PROP_BUILD_STRING.Sensitive = false;
            chkPATCH_BUILD_PROP_CAMERA_RES.Sensitive = false;
            chkPATCH_BUILD_PROP_CAMERA_VID_BPS.Sensitive = false;
            chkPATCH_BUILD_PROP_CAMERA_VID_FPS.Sensitive = false;
            chkPATCH_BUILD_PROP_CAMERA_AUD_BPS.Sensitive = false;
            chkPATCH_BUILD_PROP_CAMERA_AUD_FREQ.Sensitive = false;
        }
    }

    protected virtual void OnChkPATCHBUILDPROPBUILDSTRINGToggled(object sender, System.EventArgs e)
    {
        if (chkPATCH_BUILD_PROP_BUILD_STRING.Active)
            txtPATCH_BUILD_PROP_BUILD_STRING.Sensitive = true;
        else
            txtPATCH_BUILD_PROP_BUILD_STRING.Sensitive = false;
    }

    protected virtual void OnChkPATCHBUILDPROPCAMERARESToggled(object sender, System.EventArgs e)
    {
        if (chkPATCH_BUILD_PROP_CAMERA_RES.Active)
            cmbPATCH_BUILD_PROP_CAMERA_RES.Sensitive = true;
        else
            cmbPATCH_BUILD_PROP_CAMERA_RES.Sensitive = false;
    }

    protected virtual void OnCmbPATCHBUILDPROPCAMERARESChanged(object sender, System.EventArgs e)
    {
        if (cmbPATCH_BUILD_PROP_CAMERA_RES.Active == 3)
        {
            txtCamResX.Sensitive = true;
            txtCamResY.Sensitive = true;
        }
        else
        {
            txtCamResX.Sensitive = false;
            txtCamResY.Sensitive = false;
        }
    }

    protected virtual void OnChkPATCHBUILDPROPCAMERAVIDBPSToggled(object sender, System.EventArgs e)
    {
        if (chkPATCH_BUILD_PROP_CAMERA_VID_BPS.Active)
            txtPATCH_BUILD_PROP_CAMERA_VID_BPS.Sensitive = true;
        else
            txtPATCH_BUILD_PROP_CAMERA_VID_BPS.Sensitive = false;
    }

    protected virtual void OnChkPATCHBUILDPROPCAMERAVIDFPSToggled(object sender, System.EventArgs e)
    {
        if (chkPATCH_BUILD_PROP_CAMERA_VID_FPS.Active)
            txtPATCH_BUILD_PROP_CAMERA_VID_FPS.Sensitive = true;
        else
            txtPATCH_BUILD_PROP_CAMERA_VID_FPS.Sensitive = false;
    }

    protected virtual void OnChkPATCHBUILDPROPCAMERAAUDBPSToggled(object sender, System.EventArgs e)
    {
        if (chkPATCH_BUILD_PROP_CAMERA_AUD_BPS.Active)
            txtPATCH_BUILD_PROP_CAMERA_AUD_BPS.Sensitive = true;
        else
            txtPATCH_BUILD_PROP_CAMERA_AUD_BPS.Sensitive = false;
    }

    protected virtual void OnChkPATCHBUILDPROPCAMERAAUDFREQToggled(object sender, System.EventArgs e)
    {
        if (chkPATCH_BUILD_PROP_CAMERA_AUD_FREQ.Active)
            txtPATCH_BUILD_PROP_CAMERA_AUD_FREQ.Sensitive = true;
        else
            txtPATCH_BUILD_PROP_CAMERA_AUD_FREQ.Sensitive = false;
    }

    protected virtual void OnChkINSTALLBUSYBOXToggled(object sender, System.EventArgs e)
    {
        if (chkINSTALL_BUSYBOX.Active)
            chkINSTALL_BUSYBOX_LINK_XBIN.Sensitive = true;
        else
            chkINSTALL_BUSYBOX_LINK_XBIN.Sensitive = false;
    }
    protected virtual void OnChkRESTOREBACKUPToggled(object sender, System.EventArgs e)
    {
        if (chkRESTORE_BACKUP.Active)
            notebook4.Sensitive = false;
        else
            notebook4.Sensitive = true;
    }
	
		
    protected virtual void OnWidgetClicked (object sender, System.EventArgs e)
	{
		lblHelp.Text = help.GetHelpText((Gtk.Widget)sender);
	}
	
    protected virtual void ClearHelpLabel (object o, System.EventArgs e)
	{
		lblHelp.Text = "";
	}
}